using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using ScmGroup.XCam.Scripting;
using ScmGroup.XCam.MachiningDataModel;

namespace ScmGroup.XCam.ScriptingMacros
{
    /// <summary>
    /// Class
    /// </summary>
    [DataContract]
    public class SawCut_Peanut : UserScript
    {
        /// <summary>
        /// SawCut Boring
        /// </summary>
        public SawCut_Peanut()
            : base()
        {
            Name = "SawCut_Peanut";

			AddParameter("WorkpieceLength", 1200, typeof(Double), "WorkpieceLengthDescription", ParameterType.WorkpieceLength, false, FisicalUnitType.Lenght, false);
			AddParameter("WorkpieceWidth", 800, typeof(Double), "WorkpieceWidthDescription", ParameterType.WorkpieceWidth, false, FisicalUnitType.Lenght, false);
			AddParameter("WorkpieceHeight", 800, typeof(Double), "WorkpieceHeightDescription", ParameterType.WorkpieceHeight, false, FisicalUnitType.Lenght, false);
			AddParameter("X", "dx", typeof(Double), "Start X", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("Y", 0, typeof(Double), "Start Y", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("xe", "dx", typeof(Double), "End X", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("ye", "dy", typeof(Double), "End Y", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("Angle", 0, typeof(Double), "Angle", ParameterType.UserDefined, false, FisicalUnitType.UnitLess, false);
			AddParameter("IType", 1, typeof(Int32), "Incisition type", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameterValue("IncT1", 1, true);
			AddParameterValue("IncT0", 0, false);
			AddParameterValue("IncT2", 2, false);
			AddParameterValue("IncT3", 3, false);
			AddParameterValue("IncT4", 4, false);
			AddParameterValue("IncT5", 5, false);
			AddParameterValue("IncT6", 6, false);
			AddParameterValue("IncT7", 7, false);
			AddParameterValue("IncT8", 8, false);
			AddParameter("Depth", "dz", typeof(Double), "Sawdepth if equal to thickness piece complete cut will be done", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("IDepth", 5, typeof(Double), "Incisition depth on top", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("ODepth", null, typeof(Double), "OverDepth for the cutting part (default 15 if SAFDIST in parameterfile is defined)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("IFDepth", 1, typeof(Double), "Inc.edge depth", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("IDist", 0.05, typeof(Double), "Incisition distance", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("OLengthIn", null, typeof(Double), "LeadIn-length (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("OLengthOut", null, typeof(Double), "LeadOut-length (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("FeedIn", null, typeof(Double), "Feed incisition (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Speed, true);
			AddParameter("FeedCut", null, typeof(Double), "Feed saw (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Speed, true);
			AddParameter("FeedDia", 2, typeof(Double), "Feed diarouter", ParameterType.UserDefined, true, FisicalUnitType.Speed, false);
			AddParameter("HeadS", "3", typeof(String), "Head saw", ParameterType.Head, true, FisicalUnitType.UnitLess, false);
			AddParameter("ToolS", "E040", typeof(String), "Saw", ParameterType.Tool, true, FisicalUnitType.UnitLess, true);
			AddParameter("RotSS", null, typeof(Double), "Rotation saw (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("HeadD", "3", typeof(String), "Head Diarouter", ParameterType.Head, true, FisicalUnitType.UnitLess, false);
			AddParameter("ToolD", "E004", typeof(String), "Diarouter", ParameterType.Tool, true, FisicalUnitType.UnitLess, true);
			AddParameter("RotSD", null, typeof(Double), "Rotation Diarouter (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("RefPos", 0, typeof(Double), "Referencepositon  auto / top / bottom", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameterValue("Auto", 0, true);
			AddParameterValue("Ob", 1, false);
			AddParameterValue("Un", 2, false);
			AddParameter("IDDist", 0, typeof(Double), "Dist.PreRouting horizontal end frontal", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("Info", false, typeof(Boolean), "InfoCode", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameter("Cor", -1, typeof(Int32), "Correction auto - left - center - right", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameterValue("IO_Auto", -1, true);
			AddParameterValue("OI_L", 1, false);
			AddParameterValue("IOI_C", 0, false);
			AddParameterValue("IO_R", 2, false);
			AddParameter("BDepth", null, typeof(Double), "Depth (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("BStop", 0, typeof(Double), "movement after cut 0 = none / position", ParameterType.UserDefined, true, FisicalUnitType.Lenght, false);
			AddParameter("BNr", null, typeof(Double), "Nr. of holes (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("BExDist", null, typeof(Double), "lateral distance of the holes begin and end (empty=default)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("BMaxDist", null, typeof(Double), "Maximum distance beetween the holes (empty=default)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("SawOn", false, typeof(Boolean), "Cuttin on", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameter("HeadB", "3", typeof(String), "Head boring", ParameterType.Head, true, FisicalUnitType.UnitLess, false);
			AddParameter("ToolB", "E093", typeof(String), "Tool joint", ParameterType.Tool, true, FisicalUnitType.UnitLess, true);
			AddParameter("RotSB", null, typeof(Double), "Rotation boring (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("FeedBor", null, typeof(Double), "Feed boring (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.Speed, true);
			AddParameter("BLength", null, typeof(Double), "routed length ELA3D between the 2 middles of the routings  (empty=default)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("HoodS", null, typeof(Double), "Hood saw (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("HoodB", null, typeof(Double), "Hood boing (empty=auto.)", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
			AddParameter("BPos", null, typeof(Double), "Position of ELA3D from the upper side on inclined surfaces  (empty=default)", ParameterType.UserDefined, true, FisicalUnitType.Lenght, true);
			AddParameter("LatMov", 0, typeof(Double), "Lateral movement to allow adjustments in the joint", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameter("JointType", 0, typeof(Double), "JointTypeDescription", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, false);
			AddParameterValue("Peanut_1", 0, true);
			AddParameterValue("VertRout", 1, false);
			AddParameterValue("Peanut_2_Top", 2, false);
			AddParameterValue("Peanut_2_Side", 3, false);
			AddParameter("SpD25", null, typeof(String), "Spindlenumber for the diameter 25 hole of peanut 1 if the optimizer is not used", ParameterType.Tool, true, FisicalUnitType.UnitLess, true);
			AddParameter("SpD5", null, typeof(String), "Spindlenumber for the diameter 5 hole of peanut 1 if the optimizer is not used", ParameterType.Tool, true, FisicalUnitType.UnitLess, true);
			AddParameter("AngleZ", null, typeof(Double), "Angle arround Z if the Start- and Endpoint are the same", ParameterType.UserDefined, true, FisicalUnitType.UnitLess, true);
        }

        /// <summary>
        /// Execute-Method of the Scripts.
        /// </summary>
        /// <param name="WorkpieceLength">WorkpieceLengthDescription.</param>
        /// <param name="WorkpieceWidth">WorkpieceWidthDescription.</param>
        /// <param name="WorkpieceHeight">WorkpieceHeightDescription.</param>
        /// <param name="Parameter">ParameterDescription.</param>
        /// <param name="Parameter1">Parameter1Description.</param>
        /// <param name="Parameter2">Parameter2Description.</param>
        /// <param name="Parameter3">Parameter3Description.</param>
        /// <param name="Parameter4">Parameter4Description.</param>
        /// <param name="Parameter5">Parameter5Description.</param>
        /// <param name="Parameter6">Parameter6Description.</param>
        /// 

		public Object Execute(Double WorkpieceLength, Double WorkpieceWidth, Double WorkpieceHeight, Double X, Double Y, Double xe, Double ye, Double Angle, Int32 IType, Double Depth, Double IDepth, Double? ODepth, Double IFDepth, Double IDist, Double? OLengthIn, Double? OLengthOut, Double? FeedIn, Double? FeedCut, Double FeedDia, String HeadS, String ToolS, Double? RotSS, String HeadD, String ToolD, Double? RotSD, Double RefPos, Double IDDist, Boolean Info, Int32 Cor, Double? BDepth, Double BStop, Double? BNr, Double? BExDist, Double? BMaxDist, Boolean SawOn, String HeadB, String ToolB, Double? RotSB, Double? FeedBor, Double? BLength, Double? HoodS, Double? HoodB, Double? BPos, Double LatMov, Double JointType, String SpD25, String SpD5, Double? AngleZ)
        {

            // ITYPE
            // Incisition TOP with blade =    1 - 2 - 4 - 6 - 7 - 8
            // Incisition EDGE with blade =   2 - 7
            // Prerout EDGE with router =     3 - 4 - 8
            // Prerout HOR with router =      5 - 6 - 7 - 8
            // IType = 5;

            //##################################################################################################################################################
            //                                                                                             AUTOMATIC SETTINGS AND DECISITIONS
            //Init Block SCM-D
            double DX = WorkpieceLength; double DY = WorkpieceWidth; double DZ = WorkpieceHeight;
            //
            int C = 0; if (C != 0) C = 3 - C; //Changes Maestro-Cor to Xilog-Cor
            //
            //Init Block SCM-D

            // default parameters ----------------------------------------------------------
            Double PEANUTEXDISI = GetParameterDefaultValue<Double>("PEANUTEXDISI", 50);      // JOint EXtern DIStanze --> changed to BExDist - coming out of the mainparameters
            Double PEANUTMADISBW = GetParameterDefaultValue<Double>("PEANUTMADISBW", 160);       // MAximum DIStance BetWeen joints  --> changed to BMaxDist - coming out of the mainparameters
            Double PEANUTDEPTH = GetParameterDefaultValue<Double>("PEANUTDEPTH", 12.5); // Depth of the routing;
            Double PEANUTLENGTH = GetParameterDefaultValue<Double>("PEANUTLENGTH", 36.5); // Length of the routing;
            Double PEANUTPOS = GetParameterDefaultValue<Double>("PEANUTPOS", 9.1); // Position of routing in inclined cuts;
            // default parameters ----------------------------------------------------------

            Boolean OLengthIn_HASVALUE = OLengthIn.HasValue; if (OLengthIn_HASVALUE == false) OLengthIn = -1;
            Boolean OLengthOut_HASVALUE = OLengthOut.HasValue; if (OLengthOut_HASVALUE == false) OLengthOut = -1;
            Boolean FeedIn_HASVALUE = FeedIn.HasValue; if (FeedIn_HASVALUE == false) FeedIn = -1;
            Boolean FeedCut_HASVALUE = FeedCut.HasValue; if (FeedCut_HASVALUE == false) FeedCut = -1;
            Boolean FeedBor_HASVALUE = FeedBor.HasValue; if (FeedBor_HASVALUE == false) FeedBor = -1;
            Boolean RotSS_HASVALUE = RotSS.HasValue; if (RotSS_HASVALUE == false) RotSS = -1;
            Boolean RotSD_HASVALUE = RotSD.HasValue; if (RotSD_HASVALUE == false) RotSD = -1;
            Boolean RotSB_HASVALUE = RotSB.HasValue; if (RotSB_HASVALUE == false) RotSB = -1;
            Boolean BNr_HASVALUE = BNr.HasValue; if (BNr_HASVALUE == false) BNr = -1;
            Boolean BExDist_HASVALUE = BExDist.HasValue; if (BExDist_HASVALUE == false) BExDist = -1;
            Boolean BMaxDist_HASVALUE = BMaxDist.HasValue; if (BMaxDist_HASVALUE == false) BMaxDist = -1;
            Boolean BDepth_HASVALUE = BDepth.HasValue; if (BDepth_HASVALUE == false) BDepth = -1;
            Boolean BPos_HASVALUE = BPos.HasValue; if (BPos_HASVALUE == false) BPos = -1;
            Boolean BLength_HASVALUE = BLength.HasValue; if (BLength_HASVALUE == false) BLength = -1;


            double BExDist_Out = BExDist ?? -1;
            double BMaxDist_Out = BMaxDist ?? -1;
            double BNr_Out = BNr ?? -1;
            double RotSB_Out = RotSB ?? -1;
            double FeedBor_Out = FeedBor ?? -1;
            double BDepth_Out = BDepth ?? -1;
            double BPos_Out = BPos ?? -1;
            double BLength_Out = BLength ?? -1;
            double AngleZ_Out = AngleZ ?? 0;
            // ODepth is also a ?Double but goes directely with his value to the CreateMacro function

            if ((PEANUTEXDISI != -1) && (BExDist_Out == -1)) BExDist_Out = PEANUTEXDISI;
            if ((PEANUTMADISBW != -1) && (BMaxDist_Out == -1)) BMaxDist_Out = PEANUTMADISBW;
            if ((PEANUTDEPTH != -1) && (BDepth_Out == -1)) BDepth_Out = PEANUTDEPTH;
            if ((PEANUTPOS != -1) && (BPos_Out == -1)) BPos_Out = PEANUTPOS;
            if ((PEANUTLENGTH != -1) && (BLength_Out == -1)) BLength_Out = PEANUTLENGTH;


            if (JointType == 0) // 25 + 5 mm hole
            {
                if ((SpD25 == "") && (SpD5 == ""))
                {
                    //SetPreserveWorkingSequence(true);
                    //SetMultipleDrillingsCanChangeWorkingSequence(true);
                }
            }
            // AngelSEtting 
            if (JointType < 3)
            {
                Angle = 0;
            }
            else
            {
                Angle = 90;
            }


            double SawAngle = 90; // Deactivating saw if positionof cut would be wrong
            if (((X == 0) && (xe == 0)) || ((X == DX) && (xe == DX)) || ((Y == 0) && (ye == 0)) || ((Y == DY) && (ye == DY)))
            {
            }
            else
            {
                if ((JointType == 1)  || (JointType == 2)) SawOn = false;
            }

            if (SawOn == true)
            {
                CreateMacro("SawCut_PEANUT_CutPart", "SawCut", X, Y, xe, ye, SawAngle, IType, Depth, IDepth, ODepth, IFDepth, IDist, OLengthIn, OLengthOut, FeedIn, FeedCut, FeedDia, HeadS, ToolS, RotSS, HeadD, ToolD, RotSD, RefPos, IDDist, Info, Cor, HoodS, SawOn);
                if (BStop != 0)
                {
                    Boolean isXSpecularity = false;          // default
                    String fieldName = "AB";                 // default
                    MachineParameters machineParameters = GetMachiningParameters();
                    if (machineParameters != null)
                    {
                        fieldName = machineParameters.Field;
                        WorkingField workingField = GetWorkingField(fieldName);
                        isXSpecularity = workingField.SpecularityX;
                    }
                    string FN = fieldName.Substring(0, 1);
                    if (((FN == "H") || (FN == "P") || (FN == "L") || (FN == "D")) && (isXSpecularity == false)) // Right field without mirror on 
                    {
                        CreateNullOperation("Park", -BStop, 0, 1);
                    }
                    else
                    {
                        CreateNullOperation("Park", DX + BStop, 0, 1);
                    }
                }
            }

            if ((ToolB == "") && (JointType == 1))
            {
                Print("@Msg1"); // No router selected
                return null;
            }
            
            double BToolRad = 0;
            if (JointType == 1)
            {
                Tool BTool = GetTool(ToolB);
                if (BTool != null)
                {
                    BToolRad = BTool.Radius;
                }
            }
            double BohrVerSZ = BToolRad * sin(Angle);
            double GegKaBo = Depth / 3 * 2 - BohrVerSZ;
            double HypBo = GegKaBo / sin(90 - Angle);

            double CQUA = ((xe - X) * (xe - X)) + ((ye - Y) * (ye - Y));

            double HYP = Math.Sqrt(CQUA);

            double NETLA = HYP - BExDist_Out * 2;
            double RASAB = 0;
            double ANZ = 0;
            if (BNr_Out > 0)
            {
                if (BNr_Out == 2)
                {
                    RASAB = NETLA;
                    ANZ = BNr_Out - 1;
                }
                else
                {
                    RASAB = NETLA / (BNr_Out - 1);
                    ANZ = BNr_Out - 1;
                }
            }
            else
            {
                ANZ = NETLA / BMaxDist_Out;
                ANZ = Math.Ceiling(ANZ);
                RASAB = NETLA / ANZ;
            }

            Double DisX = xe - X;
            Double DisY = ye - Y;
            Double Anwink = 0;
            if ((DisX != 0) && (DisY != 0))
            {
                Anwink = 90 - (Math.Atan(DisX / DisY) * 180 / Math.PI);
            }
            else
            {
                if (DisX > 0)
                {
                    Anwink = 0;
                }
                else
                {
                    if (DisX < 0)
                    {
                        Anwink = 180;
                    }
                }
                if (DisY > 0)
                {
                    Anwink = 90;
                }
            }
            if (DisY < 0)
            {
                if (DisX == 0)
                {
                    Anwink = -90;
                }
                else
                {
                    Anwink = (180 - Anwink) * -1;
                }
            }
            if ((DisX == 0) && (DisY == 0))
            {
                Anwink = AngleZ_Out;
                if (BExDist_HASVALUE == false) BExDist_Out = 0;
            }
            double LanVers = 0;
            Boolean REFOB = true;
            if (RefPos == 0)
            {
                if (Angle <= 90) REFOB = false;
            }
            else
            {
                if (RefPos == 2) REFOB = false;
            }
            double BasX = 0;
            double BasY = 0;
            if (REFOB == true)
            {
                LanVers = Depth / Math.Tan(Angle / 180 * Math.PI); // radiant value to angle
                BasX = X + LanVers * cos(Anwink - 90); // Pos if REFOB == TRUE
                BasY = Y + LanVers * sin(Anwink - 90); // Pos if REFOB == TRUE
            }
            else
            {
                BasX = X;
                BasY = Y;
            }

            double BPO = BExDist_Out;
            double KALAN = Depth / SIN(Angle);// length of surface

            double FrPosY = KALAN - BPos_Out; // Position of Routing from Bottom piece
            if (Angle == 90)
            {
                if (BPos_Out == -1)
                {
                    FrPosY = 5.1;
                }
                else
                {
                    FrPosY = DZ-BPos_Out;
                }
            }
                
                
            double FrPosX = BExDist_Out;
           // if (ANZ == 1) FrPosX = HYP / 2;

            ANZ = ANZ + 1;
            Int32 ZAEL = 0;


            // CreateDrill - GM said that the Diameter musst be the same as the tool the Drilltype must be "-" 
            SelectWorkplane("Top");

            if (Angle != 0)
            {
                CreateWorkplane("SawCut_Peanut_Plane", BasX, BasY, 0, Anwink, Angle);
            }
            else
            {
                CreateWorkplane("SawCut_Peanut_Plane", X, Y, DZ, Anwink, 0);
                if (BPos_HASVALUE == false)
                {
                    if ((((X == 0) && (xe == 0)) || ((X == DX) && (xe == DX)) || ((Y == 0) && (ye == 0)) || ((Y == DY) && (ye == DY))) && (Angle == 0) && (JointType != 0))
                    {
                        FrPosY = DZ-BPos_Out;
                    }
                    else
                    {
                        FrPosY = 0;
                    }
                }
                else
                {
                    FrPosY = BPos_Out;
                }
            }
            do
            {
                if (JointType == 0) // 25 + 5 mm hole
                {
                    if (SpD5 == "")
                    {
                        SetPriority(100);
                        CreateDrill("Peanut5_Hole" + ZAEL, FrPosX, FrPosY + 11.456 + 11.5, 13.4, 5, "", TypeOfProcess.Drilling, "-1", "-1", 0, -1, -1, "P", 0, null);
                    }
                    else
                    {
                        //SetPriority(100);
                        CreateDrill("Peanut5_Hole" + ZAEL, FrPosX, FrPosY + 11.456 + 11.5, 13.4, 5, "", TypeOfProcess.Drilling, SpD5, "-1", 0, -1, -1, "P", 0, null);
                    }
                    if (SpD25 == "")
                    {
                        SetPriority(50);
                        CreateDrill("Peanut25_Hole" + ZAEL, FrPosX, FrPosY + 11.456, 13.4, 25, "", TypeOfProcess.Drilling, "-1", "-1", 0, -1, -1, "P", 0, null);
                    }
                    else
                    {
                        SetPriority(50);
                        CreateDrill("Peanut25_Hole" + ZAEL, FrPosX, FrPosY + 11.456, 13.4, 25, "", TypeOfProcess.Drilling, SpD25, "-1", 0, -1, -1, "P", 0, null);
                    }
                }
                if (JointType == 1) // routing
                {
                    CreatePolyline("Saw_Cut_PEANUT_Joint_" + ZAEL, FrPosX - BLength_Out, FrPosY);
                    AddSegmentToPolyline(FrPosX, FrPosY + LatMov / 2);
                    if (LatMov > 0) AddSegmentToPolyline(FrPosX, FrPosY - LatMov / 2);
                    AddSegmentToPolyline(FrPosX - BLength_Out, FrPosY);
                    CreateRoughFinish("Saw_Cut_Peanut_Routing_" + ZAEL, BDepth_Out, "Saw_Cut_Peanut_JointSlot", TypeOfProcess.GeneralRouting, ToolB, HeadB, 0, -1, RotSB_Out, FeedBor, 0);
                }
                if (JointType == 2) // 6 mm hole TOP
                {
                    CreateDrill("Peanut6_HoleTop" + ZAEL, FrPosX, FrPosY, 13.4, 6, "", TypeOfProcess.Drilling, "-1", "-1", 0, -1, -1, "P", 0, null);
                }
                if (JointType == 3) // 6 mm hole Side
                {
                    //FrPosY = 9.1;
                    CreateDrill("Peanut6_HoleSide" + ZAEL, FrPosX, FrPosY, 13.4, 6, "", TypeOfProcess.Drilling, "-1", "-1", 0, -1, -1, "P", 0, null);
                }
                ZAEL = ZAEL + 1;
                FrPosX = FrPosX + RASAB;
            }
            while (ZAEL < ANZ);

            return null;
        }

        /// <summary>
        /// Validate-Method of the Scripts.
        /// </summary>
        /// <param name="WorkpieceLength">WorkpieceLengthDescription.</param>
        /// <param name="WorkpieceWidth">WorkpieceWidthDescription.</param>
        /// <param name="WorkpieceHeight">WorkpieceHeightDescription.</param>
        /// <param name="Parameter">ParameterDescription.</param>
        /// <param name="Parameter1">Parameter1Description.</param>
        /// <param name="Parameter2">Parameter2Description.</param>
        /// <param name="Parameter3">Parameter3Description.</param>
        /// <param name="Parameter4">Parameter4Description.</param>
        /// <param name="Parameter5">Parameter5Description.</param>
        /// <param name="Parameter6">Parameter6Description.</param>
		public void Validate(Double WorkpieceLength, Double WorkpieceWidth, Double WorkpieceHeight, Double X, Double Y, Double xe, Double ye, Double Angle, Int32 IType, Double Depth, Double IDepth, Double? ODepth, Double IFDepth, Double IDist, Double? OLengthIn, Double? OLengthOut, Double? FeedIn, Double? FeedCut, Double FeedDia, String HeadS, String ToolS, Double? RotSS, String HeadD, String ToolD, Double? RotSD, Double RefPos, Double IDDist, Boolean Info, Int32 Cor, Double? BDepth, Double BStop, Double? BNr, Double? BExDist, Double? BMaxDist, Boolean SawOn, String HeadB, String ToolB, Double? RotSB, Double? FeedBor, Double? BLength, Double? HoodS, Double? HoodB, Double? BPos, Double LatMov, Double JointType, String SpD25, String SpD5, Double? AngleZ)
        {
        }

    }
}
